/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Store.xs. Do not edit this file, edit Store.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Store.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "INLINE.h"
#ifndef HREG_H_
#define HREG_H_

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <stdint.h>

/*#define HR_DEBUG*/

//#define HR_DEBUG

#ifndef HR_DEBUG
static int _hr_enable_debug = -1;
#define _hr_can_debug \
    (_hr_enable_debug >= 0 ? _hr_enable_debug : \
        (_hr_enable_debug = getenv("HR_DEBUG") ? 1 : 0))

#define HR_DEBUG(fmt, ...) if(_hr_can_debug) { \
    fprintf(stderr, "[%s:%d (%s)] " fmt "\n", \
        __FILE__, __LINE__, __func__, ## __VA_ARGS__); \
}
#endif

#define _hashref_eq(r1, r2) \
    (SvROK(r1) && SvROK(r2) && \
    SvRV(r1) == SvRV(r2))


#define _mg_action_list(mg) (HR_Action*)mg->mg_ptr

static inline void
_mk_ptr_string(char *str, size_t value)
{
/*Pirated from:
 http://code.google.com/p/stringencoders/
*/
    char* wstr=str;
    char aux;
    // Conversion. Number is reversed.
    
    do *wstr++ = (char)(48 + (value % 10)); while (value /= 10);
    *wstr='\0';
    
    // Reverse string
    wstr--;
    while (wstr > str)
        aux = *wstr, *wstr-- = *str, *str++ = aux;
}

//#define mk_ptr_string(vname, ptr) \
//    char vname[128] = { '\0' }; \
//    sprintf(vname, "%lu", ptr);

#define mk_ptr_string(vname, ptr) \
    char vname[128]; \
    _mk_ptr_string(vname, (size_t)ptr);

#ifdef __GNUC__
#define inline __inline__
#endif

#if __STDC__ && __STDC_VERSION__ <= 199409L && !defined __GNUC__
#warning "c89 mode and GCC not detected. Not using inline"
#define HR_INLINE static
#else
#define HR_INLINE static inline
#endif

#define HR_TABLE_ARRAY

/*Memory Stuff*/

//#define HR_PERL_MALLOC

#ifdef HR_PERL_MALLOC
#warning "Using Perl_malloc"
#undef Perl_malloc
#undef Perl_mfree

#define Newxz_Action(ptr) \
    ptr = Perl_malloc(sizeof(HR_Action)); \
    Zero(ptr, 1, HR_Action);

#define Newxz_Action_len(ptr, extra_len) \
    ptr = Perl_malloc(sizeof(HR_Action) + extra_len); \
    Zero(ptr, 1, HR_Action);

#define Resize_Action_tail(ptr, tail_len) \
    ptr = Perl_realloc(ptr, sizeof(HR_Action)+tail_len);

#define Free_Action(ptr) \
    Perl_mfree(ptr);

#else /*!HR_PERL_MALLOC*/
       
#define Newxz_Action(ptr) \
    Newxz(ptr, 1, HR_Action)

#define Free_Action(ptr) \
    Safefree(ptr);

#endif

/*action tail functions*/

#define action_is_tailed_nocheck(actionp) \
    ((actionp->flags & HR_FLAG_STR_NO_ALLOC) == 0)

#define action_is_tailed(actionp) \
    (actionp->ktype == HR_KEY_TYPE_STR && action_is_tailed_nocheck(actionp))

#define action_keystr(actionp) \
    (action_is_tailed_nocheck(actionp)) ? \
        (char*)(((char*)actionp)+sizeof(HR_Action)) : \
        actionp->key

#define action_keylen(actionp) \
    (action_is_tailed_nocheck(actionp)) ? \
        (size_t)(actionp->key) : \
        strlen(actionp->key)

#define HREG_API_INTERNAL

typedef enum {
    HR_ACTION_TYPE_NULL         = 0,
    HR_ACTION_TYPE_DEL_AV       = 1,
    HR_ACTION_TYPE_DEL_HV       = 2,
    HR_ACTION_TYPE_CALL_CV      = 3,
    HR_ACTION_TYPE_CALL_CFUNC   = 4
} HR_ActionType_t;

typedef enum {
    HR_KEY_TYPE_NULL            = 0,
    HR_KEY_TYPE_PTR             = 1,
    HR_KEY_TYPE_STR             = 2,
    
    
    /*Extended options for searching*/
    /*RV implies we should:
     1) check the flags to see if the stored key is an RV,
     2) compare the keys performing SvRV on the stored key,
        assume current search spec is already dereferenced
    */
    HR_KEY_STYPE_PTR_RV          = 100,
    /*Sometimes a container is opaque (like a C callback)*/
    HR_KEY_SFLAG_HASHREF_OPAQUE  = 0x2000
    
} HR_KeyType_t;

typedef enum {
    HR_ACTION_NOT_FOUND,    /*Action was not found in the list*/
    HR_ACTION_DELETED,      /*Deletion OK*/
    HR_ACTION_EMPTY         /*No more actions left in the table. Hint for unmagic*/
} HR_DeletionStatus_t;


enum {
    HR_FLAG_STR_NO_ALLOC        = 1 << 0, /*Do not copy/allocate/free string*/
    HR_FLAG_HASHREF_WEAKEN      = 1 << 1, /*Weaken hashref, assumes HASHREF_RV*/
    HR_FLAG_SV_REFCNT_DEC       = 1 << 2, /*Key is an SV whose REFCNT we should decrease*/
    HR_FLAG_PTR_NO_STRINGIFY    = 1 << 3, /*Do not stringify the pointer*/
    HR_FLAG_HASHREF_RV          = 1 << 4, /*hashref is a reference, not a plain SV*/
};

/*We re-use the STR_NO_ALLOC field for an SV flag, which is obviously a TYPE_PTR*/
#define HR_FLAG_SV_KEY (1<<0)

#define action_key_is_rv(aptr) ((aptr)->flags & HR_FLAG_SV_REFCNT_DEC)
#define action_container_is_sv(aptr) ((aptr->atype != HR_ACTION_TYPE_CALL_CFUNC))
#define action_container_is_rv(aptr) ((aptr->flags & (HR_FLAG_HASHREF_RV)))
typedef struct HR_Action HR_Action;
typedef void(*HR_ActionCallback)(void*,SV*,HR_Action*);

struct
__attribute__((__packed__))
HR_Action {
    HR_Action   *next;
    void        *key;       /*Key*/
    unsigned int atype : 3; /*Action type*/
    unsigned int ktype : 2; /*Key type*/
    SV          *hashref;   /*Container*/
    unsigned int flags : 5; /*Flags*/
};

/*This will clear an action's data fields, while keeping the next pointer
 for the linked list*/

#define action_clear(actionp) \
    Zero(((char**)actionp)+1, sizeof(HR_Action)-sizeof(HR_Action*), char);


#define HR_ACTION_LIST_TERMINATOR \
{ NULL, NULL, HR_KEY_TYPE_NULL, HR_ACTION_TYPE_NULL, 0, 0 }

/*Helper macros for common HR_Action specifications*/
#define HR_DREF_FLDS_ptr_from_hv(ptr, container) \
    { .ktype = HR_KEY_TYPE_PTR, .atype = HR_ACTION_TYPE_DEL_HV, \
      .key = (char*)(ptr), .hashref = container }

#define HR_DREF_FLDS_Nstr_from_hv(newstr, container) \
    { .ktype = HR_KEY_TYPE_STR, .atype = HR_ACTION_TYPE_DEL_HV, \
        .key = newstr, .hashref = container }

#define HR_DREF_FLDS_Estr_from_hv(estr, container) \
    { .ktype = HR_KEY_TYPE_STR, .atype = HR_ACTION_TYPE_DEL_HV, \
    .key = estr, .hashref = container, .flags = HR_FLAG_STR_NO_ALLOC }

#define HR_DREF_FLDS_arg_for_cfunc(arg, fptr) \
    { .ktype = HR_KEY_TYPE_PTR, .atype = HR_ACTION_TYPE_CALL_CFUNC, \
    .key = arg, .hashref = (SV*)fptr }

HREG_API_INTERNAL
void HR_add_action(HR_Action *action_list, HR_Action *new_action, int want_unique);

HREG_API_INTERNAL
void HR_trigger_and_free_actions(HR_Action *action_list, SV *object);

HREG_API_INTERNAL
HR_DeletionStatus_t
HR_del_action(HR_Action *action_list, SV *hashref, void *key, HR_KeyType_t ktype);

HREG_API_INTERNAL
HR_DeletionStatus_t
HR_nullify_action(HR_Action *action_list, SV *hashref, void *key, HR_KeyType_t ktype);

HREG_API_INTERNAL
HR_Action*
HR_free_action(HR_Action *action);
/*
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
/// Perl Functions                                                           ///
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
*/
HREG_API_INTERNAL
void HR_add_actions_real(SV *objref, HR_Action *actions);

/*Perl API*/

void HR_PL_add_action_ptr(SV *objref, SV *hashref);
void HR_PL_add_action_str(SV *objref, SV *hashref, char *key);

void HR_PL_del_action_ptr(SV *object, SV *hashref, UV addr);
void HR_PL_del_action_str(SV *object, SV *hashref, char *str);
void HR_PL_del_action_container(SV *object, SV *hashref);
void HR_PL_del_action_sv(SV *object, SV *hashref, SV *keysv);


/*More extended deletion type..*/
void HR_XS_del_action_ext(SV *object, void *container,
						  void *arg, HR_KeyType_t ktype);


/*This is mainly for Ref::Destructor, and allows a more versatile, possibly
 slower, but safer specification of actions. Specifically, the target object
 will always be a reference (though it can be weakened)
*/

void HR_PL_add_action_ext(
    SV *objref, UV key, unsigned int atype, unsigned int ktype, SV *hashref,
    unsigned int flags);


/* H::R implementation */

SV*		HRXSK_new(char *package, char *key, SV *forward, SV *scalar_lookup);
char*	HRXSK_kstring(SV* self);
UV		HRXSK_prefix_len(SV *self);
void 	HRXSK_ithread_postdup(SV *newself, SV *newtable, HV *ptr_map, UV old_table);

SV* 	HRXSK_encap_new(char *package, SV *encapsulated_object,
                    SV *table, SV *forward, SV *scalar_lookup);
UV 		HRXSK_encap_kstring(SV *ksv_ref);
void 	HRXSK_encap_weaken(SV *ksv_ref);
void 	HRXSK_encap_link_value(SV *self, SV *value);
SV*  	HRXSK_encap_getencap(SV *self);


void 	HRXSATTR_unlink_value(SV *aobj, SV *value);
SV*  	HRXSATTR_get_hash(SV *aobj);
char*	HRXSATTR_kstring(SV *aobj);
UV		HRXSATTR_prefix_len(SV *aobj);
SV*		HRXSATTR_encap_ukey(SV *aobj);

void HRXSK_encap_ithread_predup(SV *self, SV *table, HV *ptr_map, SV *value);
void HRXSK_encap_ithread_postdup(SV *newself, SV *newtable, HV *ptr_map, UV old_table);

void HRXSATTR_ithread_predup(SV *self, SV *table, HV *ptr_map);
void HRXSATTR_ithread_postdup(SV *newself, SV *newtable, HV *ptr_map);

/*H::R API*/
void 	HRA_table_init(SV *self);
void 	HRA_store_sk(SV *hr, SV *ukey, SV *value, ...);
void 	HRA_store_kt(SV *hr, SV *ukey, SV *t, SV *value, ...);
SV* 	HRA_fetch_sk(SV *hr, SV *ukey); /*we manipulate perl's stack in this one*/

void 	HRA_store_a(SV *hr, SV *attr, char *t, SV *value, ...);
void  	HRA_fetch_a(SV *hr, SV *attr, char *t);
void 	HRA_dissoc_a(SV *hr, SV *attr, char *t, SV *value);
void 	HRA_unlink_a(SV *hr, SV *attr, char *t);
SV* 	HRA_attr_get(SV *hr, SV *attr, char *t); //Do we really need this?
void 	HRA_ithread_store_lookup_info(SV *self, HV *ptr_map);

#endif /*HREG_H_*/

#line 324 "Store.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 468 "Store.c"

XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_add_action_ptr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_add_action_ptr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "objref, hashref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	objref = ST(0)
;
	SV *	hashref = ST(1)
;
#line 324 "Store.xs"
        I32* temp;
#line 485 "Store.c"
#line 326 "Store.xs"
        temp = PL_markstack_ptr++;
        HR_PL_add_action_ptr(objref, hashref);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 496 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_add_action_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_add_action_str)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "objref, hashref, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	objref = ST(0)
;
	SV *	hashref = ST(1)
;
	char *	key = (char *)SvPV_nolen(ST(2))
;
#line 342 "Store.xs"
        I32* temp;
#line 520 "Store.c"
#line 344 "Store.xs"
        temp = PL_markstack_ptr++;
        HR_PL_add_action_str(objref, hashref, key);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 531 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_del_action_ptr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_del_action_ptr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "object, hashref, addr");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	object = ST(0)
;
	SV *	hashref = ST(1)
;
	UV	addr = (UV)SvUV(ST(2))
;
#line 360 "Store.xs"
        I32* temp;
#line 555 "Store.c"
#line 362 "Store.xs"
        temp = PL_markstack_ptr++;
        HR_PL_del_action_ptr(object, hashref, addr);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 566 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_del_action_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_del_action_str)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "object, hashref, str");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	object = ST(0)
;
	SV *	hashref = ST(1)
;
	char *	str = (char *)SvPV_nolen(ST(2))
;
#line 378 "Store.xs"
        I32* temp;
#line 590 "Store.c"
#line 380 "Store.xs"
        temp = PL_markstack_ptr++;
        HR_PL_del_action_str(object, hashref, str);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 601 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_del_action_container); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_del_action_container)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "object, hashref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	object = ST(0)
;
	SV *	hashref = ST(1)
;
#line 395 "Store.xs"
        I32* temp;
#line 623 "Store.c"
#line 397 "Store.xs"
        temp = PL_markstack_ptr++;
        HR_PL_del_action_container(object, hashref);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 634 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_del_action_sv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_del_action_sv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "object, hashref, keysv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	object = ST(0)
;
	SV *	hashref = ST(1)
;
	SV *	keysv = ST(2)
;
#line 413 "Store.xs"
        I32* temp;
#line 658 "Store.c"
#line 415 "Store.xs"
        temp = PL_markstack_ptr++;
        HR_PL_del_action_sv(object, hashref, keysv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 669 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_add_action_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HR_PL_add_action_ext)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "objref, key, atype, ktype, hashref, flags");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	objref = ST(0)
;
	UV	key = (UV)SvUV(ST(1))
;
	unsigned int	atype = (unsigned int)SvUV(ST(2))
;
	unsigned int	ktype = (unsigned int)SvUV(ST(3))
;
	SV *	hashref = ST(4)
;
	unsigned int	flags = (unsigned int)SvUV(ST(5))
;
#line 434 "Store.xs"
        I32* temp;
#line 699 "Store.c"
#line 436 "Store.xs"
        temp = PL_markstack_ptr++;
        HR_PL_add_action_ext(objref, key, atype, ktype, hashref, flags);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 710 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_new)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "package, key, forward, scalar_lookup");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	char *	key = (char *)SvPV_nolen(ST(1))
;
	SV *	forward = ST(2)
;
	SV *	scalar_lookup = ST(3)
;
	SV *	RETVAL;

	RETVAL = HRXSK_new(package, key, forward, scalar_lookup);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_kstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_kstring)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = HRXSK_kstring(self);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_prefix_len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_prefix_len)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	UV	RETVAL;
	dXSTARG;

	RETVAL = HRXSK_prefix_len(self);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_ithread_postdup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_ithread_postdup)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "newself, newtable, ptr_map, old_table");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	newself = ST(0)
;
	SV *	newtable = ST(1)
;
	HV *	ptr_map;
	UV	old_table = (UV)SvUV(ST(3))
;
#line 468 "Store.xs"
        I32* temp;
#line 801 "Store.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    ptr_map = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Ref::Store::XS::cfunc::HRXSK_ithread_postdup",
				"ptr_map");
		}
	} STMT_END
;
#line 470 "Store.xs"
        temp = PL_markstack_ptr++;
        HRXSK_ithread_postdup(newself, newtable, ptr_map, old_table);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 826 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_new)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "package, encapsulated_object, table, forward, scalar_lookup");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	SV *	encapsulated_object = ST(1)
;
	SV *	table = ST(2)
;
	SV *	forward = ST(3)
;
	SV *	scalar_lookup = ST(4)
;
	SV *	RETVAL;

	RETVAL = HRXSK_encap_new(package, encapsulated_object, table, forward, scalar_lookup);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_kstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_kstring)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ksv_ref");
    {
	SV *	ksv_ref = ST(0)
;
	UV	RETVAL;
	dXSTARG;

	RETVAL = HRXSK_encap_kstring(ksv_ref);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_weaken); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_weaken)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ksv_ref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ksv_ref = ST(0)
;
#line 496 "Store.xs"
        I32* temp;
#line 893 "Store.c"
#line 498 "Store.xs"
        temp = PL_markstack_ptr++;
        HRXSK_encap_weaken(ksv_ref);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 904 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_link_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_link_value)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, value");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	SV *	value = ST(1)
;
#line 513 "Store.xs"
        I32* temp;
#line 926 "Store.c"
#line 515 "Store.xs"
        temp = PL_markstack_ptr++;
        HRXSK_encap_link_value(self, value);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 937 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_getencap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_getencap)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;

	RETVAL = HRXSK_encap_getencap(self);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_unlink_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_unlink_value)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "aobj, value");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	aobj = ST(0)
;
	SV *	value = ST(1)
;
#line 534 "Store.xs"
        I32* temp;
#line 978 "Store.c"
#line 536 "Store.xs"
        temp = PL_markstack_ptr++;
        HRXSATTR_unlink_value(aobj, value);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 989 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_get_hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_get_hash)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "aobj");
    {
	SV *	aobj = ST(0)
;
	SV *	RETVAL;

	RETVAL = HRXSATTR_get_hash(aobj);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_kstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_kstring)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "aobj");
    {
	SV *	aobj = ST(0)
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = HRXSATTR_kstring(aobj);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_prefix_len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_prefix_len)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "aobj");
    {
	SV *	aobj = ST(0)
;
	UV	RETVAL;
	dXSTARG;

	RETVAL = HRXSATTR_prefix_len(aobj);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_encap_ukey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_encap_ukey)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "aobj");
    {
	SV *	aobj = ST(0)
;
	SV *	RETVAL;

	RETVAL = HRXSATTR_encap_ukey(aobj);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_ithread_predup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_ithread_predup)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, table, ptr_map, value");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	SV *	table = ST(1)
;
	HV *	ptr_map;
	SV *	value = ST(3)
;
#line 569 "Store.xs"
        I32* temp;
#line 1093 "Store.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    ptr_map = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Ref::Store::XS::cfunc::HRXSK_encap_ithread_predup",
				"ptr_map");
		}
	} STMT_END
;
#line 571 "Store.xs"
        temp = PL_markstack_ptr++;
        HRXSK_encap_ithread_predup(self, table, ptr_map, value);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1118 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_ithread_postdup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSK_encap_ithread_postdup)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "newself, newtable, ptr_map, old_table");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	newself = ST(0)
;
	SV *	newtable = ST(1)
;
	HV *	ptr_map;
	UV	old_table = (UV)SvUV(ST(3))
;
#line 588 "Store.xs"
        I32* temp;
#line 1143 "Store.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    ptr_map = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Ref::Store::XS::cfunc::HRXSK_encap_ithread_postdup",
				"ptr_map");
		}
	} STMT_END
;
#line 590 "Store.xs"
        temp = PL_markstack_ptr++;
        HRXSK_encap_ithread_postdup(newself, newtable, ptr_map, old_table);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1168 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_ithread_predup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_ithread_predup)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, table, ptr_map");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	SV *	table = ST(1)
;
	HV *	ptr_map;
#line 606 "Store.xs"
        I32* temp;
#line 1191 "Store.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    ptr_map = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Ref::Store::XS::cfunc::HRXSATTR_ithread_predup",
				"ptr_map");
		}
	} STMT_END
;
#line 608 "Store.xs"
        temp = PL_markstack_ptr++;
        HRXSATTR_ithread_predup(self, table, ptr_map);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1216 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_ithread_postdup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRXSATTR_ithread_postdup)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "newself, newtable, ptr_map");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	newself = ST(0)
;
	SV *	newtable = ST(1)
;
	HV *	ptr_map;
#line 624 "Store.xs"
        I32* temp;
#line 1239 "Store.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    ptr_map = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Ref::Store::XS::cfunc::HRXSATTR_ithread_postdup",
				"ptr_map");
		}
	} STMT_END
;
#line 626 "Store.xs"
        temp = PL_markstack_ptr++;
        HRXSATTR_ithread_postdup(newself, newtable, ptr_map);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1264 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_table_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_table_init)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
#line 640 "Store.xs"
        I32* temp;
#line 1284 "Store.c"
#line 642 "Store.xs"
        temp = PL_markstack_ptr++;
        HRA_table_init(self);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1295 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_store_sk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_store_sk)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "hr, ukey, value, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	hr = ST(0)
;
	SV *	ukey = ST(1)
;
	SV *	value = ST(2)
;
#line 658 "Store.xs"
        I32* temp;
#line 1319 "Store.c"
#line 660 "Store.xs"
        temp = PL_markstack_ptr++;
        HRA_store_sk(hr, ukey, value);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1330 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_store_kt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_store_kt)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "hr, ukey, t, value, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	hr = ST(0)
;
	SV *	ukey = ST(1)
;
	SV *	t = ST(2)
;
	SV *	value = ST(3)
;
#line 677 "Store.xs"
        I32* temp;
#line 1356 "Store.c"
#line 679 "Store.xs"
        temp = PL_markstack_ptr++;
        HRA_store_kt(hr, ukey, t, value);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1367 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_fetch_sk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_fetch_sk)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "hr, ukey");
    {
	SV *	hr = ST(0)
;
	SV *	ukey = ST(1)
;
	SV *	RETVAL;

	RETVAL = HRA_fetch_sk(hr, ukey);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_store_a); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_store_a)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "hr, attr, t, value, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	hr = ST(0)
;
	SV *	attr = ST(1)
;
	char *	t = (char *)SvPV_nolen(ST(2))
;
	SV *	value = ST(3)
;
#line 701 "Store.xs"
        I32* temp;
#line 1414 "Store.c"
#line 703 "Store.xs"
        temp = PL_markstack_ptr++;
        HRA_store_a(hr, attr, t, value);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1425 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_fetch_a); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_fetch_a)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hr, attr, t");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	hr = ST(0)
;
	SV *	attr = ST(1)
;
	char *	t = (char *)SvPV_nolen(ST(2))
;
#line 719 "Store.xs"
        I32* temp;
#line 1449 "Store.c"
#line 721 "Store.xs"
        temp = PL_markstack_ptr++;
        HRA_fetch_a(hr, attr, t);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1460 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_dissoc_a); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_dissoc_a)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "hr, attr, t, value");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	hr = ST(0)
;
	SV *	attr = ST(1)
;
	char *	t = (char *)SvPV_nolen(ST(2))
;
	SV *	value = ST(3)
;
#line 738 "Store.xs"
        I32* temp;
#line 1486 "Store.c"
#line 740 "Store.xs"
        temp = PL_markstack_ptr++;
        HRA_dissoc_a(hr, attr, t, value);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1497 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_unlink_a); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_unlink_a)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hr, attr, t");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	hr = ST(0)
;
	SV *	attr = ST(1)
;
	char *	t = (char *)SvPV_nolen(ST(2))
;
#line 756 "Store.xs"
        I32* temp;
#line 1521 "Store.c"
#line 758 "Store.xs"
        temp = PL_markstack_ptr++;
        HRA_unlink_a(hr, attr, t);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1532 "Store.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_attr_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_attr_get)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "hr, attr, t");
    {
	SV *	hr = ST(0)
;
	SV *	attr = ST(1)
;
	char *	t = (char *)SvPV_nolen(ST(2))
;
	SV *	RETVAL;

	RETVAL = HRA_attr_get(hr, attr, t);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_ithread_store_lookup_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Ref__Store__XS__cfunc_HRA_ithread_store_lookup_info)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ptr_map");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	HV *	ptr_map;
#line 779 "Store.xs"
        I32* temp;
#line 1576 "Store.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    ptr_map = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Ref::Store::XS::cfunc::HRA_ithread_store_lookup_info",
				"ptr_map");
		}
	} STMT_END
;
#line 781 "Store.xs"
        temp = PL_markstack_ptr++;
        HRA_ithread_store_lookup_info(self, ptr_map);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 1601 "Store.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Ref__Store); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Ref__Store)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Ref::Store::XS::cfunc::HR_PL_add_action_ptr", XS_Ref__Store__XS__cfunc_HR_PL_add_action_ptr);
        newXS_deffile("Ref::Store::XS::cfunc::HR_PL_add_action_str", XS_Ref__Store__XS__cfunc_HR_PL_add_action_str);
        newXS_deffile("Ref::Store::XS::cfunc::HR_PL_del_action_ptr", XS_Ref__Store__XS__cfunc_HR_PL_del_action_ptr);
        newXS_deffile("Ref::Store::XS::cfunc::HR_PL_del_action_str", XS_Ref__Store__XS__cfunc_HR_PL_del_action_str);
        newXS_deffile("Ref::Store::XS::cfunc::HR_PL_del_action_container", XS_Ref__Store__XS__cfunc_HR_PL_del_action_container);
        newXS_deffile("Ref::Store::XS::cfunc::HR_PL_del_action_sv", XS_Ref__Store__XS__cfunc_HR_PL_del_action_sv);
        newXS_deffile("Ref::Store::XS::cfunc::HR_PL_add_action_ext", XS_Ref__Store__XS__cfunc_HR_PL_add_action_ext);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_new", XS_Ref__Store__XS__cfunc_HRXSK_new);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_kstring", XS_Ref__Store__XS__cfunc_HRXSK_kstring);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_prefix_len", XS_Ref__Store__XS__cfunc_HRXSK_prefix_len);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_ithread_postdup", XS_Ref__Store__XS__cfunc_HRXSK_ithread_postdup);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_encap_new", XS_Ref__Store__XS__cfunc_HRXSK_encap_new);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_encap_kstring", XS_Ref__Store__XS__cfunc_HRXSK_encap_kstring);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_encap_weaken", XS_Ref__Store__XS__cfunc_HRXSK_encap_weaken);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_encap_link_value", XS_Ref__Store__XS__cfunc_HRXSK_encap_link_value);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_encap_getencap", XS_Ref__Store__XS__cfunc_HRXSK_encap_getencap);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSATTR_unlink_value", XS_Ref__Store__XS__cfunc_HRXSATTR_unlink_value);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSATTR_get_hash", XS_Ref__Store__XS__cfunc_HRXSATTR_get_hash);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSATTR_kstring", XS_Ref__Store__XS__cfunc_HRXSATTR_kstring);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSATTR_prefix_len", XS_Ref__Store__XS__cfunc_HRXSATTR_prefix_len);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSATTR_encap_ukey", XS_Ref__Store__XS__cfunc_HRXSATTR_encap_ukey);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_encap_ithread_predup", XS_Ref__Store__XS__cfunc_HRXSK_encap_ithread_predup);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSK_encap_ithread_postdup", XS_Ref__Store__XS__cfunc_HRXSK_encap_ithread_postdup);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSATTR_ithread_predup", XS_Ref__Store__XS__cfunc_HRXSATTR_ithread_predup);
        newXS_deffile("Ref::Store::XS::cfunc::HRXSATTR_ithread_postdup", XS_Ref__Store__XS__cfunc_HRXSATTR_ithread_postdup);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_table_init", XS_Ref__Store__XS__cfunc_HRA_table_init);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_store_sk", XS_Ref__Store__XS__cfunc_HRA_store_sk);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_store_kt", XS_Ref__Store__XS__cfunc_HRA_store_kt);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_fetch_sk", XS_Ref__Store__XS__cfunc_HRA_fetch_sk);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_store_a", XS_Ref__Store__XS__cfunc_HRA_store_a);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_fetch_a", XS_Ref__Store__XS__cfunc_HRA_fetch_a);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_dissoc_a", XS_Ref__Store__XS__cfunc_HRA_dissoc_a);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_unlink_a", XS_Ref__Store__XS__cfunc_HRA_unlink_a);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_attr_get", XS_Ref__Store__XS__cfunc_HRA_attr_get);
        newXS_deffile("Ref::Store::XS::cfunc::HRA_ithread_store_lookup_info", XS_Ref__Store__XS__cfunc_HRA_ithread_store_lookup_info);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
